C! NASA Goddard Space Flight Center Open Source: Jan McGarry (Jan.McGarry@nasa.gov)
C! *
C! * star_data_file_struct.for
C! * This include file contains structure definitions for the star data file.
C! * Written by Jack Cheek HSTX 7-jun-93
C! * If any changes are made to this file the same changes will need to be 
C! * made in the file star_data_file.h (the C counterpart) as the structures
C! * must be properly alligned
C! * 
        parameter (nmmc =22)
        type ra_struct
           integer hrs
           integer mins
           double precision secs
        end type
        
        type dec_struct
           integer deg
           integer mins
           double precision secs
        end type
      
        type tod_struct
           integer hrs
           integer mins
           double precision secs
        end type

        type star_data_struct
           integer catalog_num
           integer starnum
           double precision star_mag
           integer sky_section
           type (ra_struct) ra
           type (dec_struct) dec
           integer year
           integer month
           integer day
           integer doy
           type (tod_struct) tod
           double precision A1
           double precision A2
           double precision B1
           double precision B2
           double precision D1
           double precision D2
        end type
  
        type star_data_file_struct
           character*30 filename
           character*30 sysname
           character*10 catalog
           integer fittype
           double precision X(nmmc)
           double precision P(nmmc,nmmc)
           double precision ut1_utc
           double precision temp
           double precision barp
           double precision humd
           double precision sigr
           double precision sigscl
           double precision pscale
           double precision smean
           double precision rmstot
           integer nok
           integer nrej
           integer NSTARS
           integer iter
           type (star_data_struct) sd(200) 
        end type

