C!!! NASA Goddard Space Flight Center Open Source: Jan McGarry (Jan.McGarry@nasa.gov)
C ==========================================================================
C STATION SPECIFIC ROUTINE FOR THE NEW CONTROLLER STAR CALIBRATION PROGRAM
C       * SLR2000 VERSION *
C ==========================================================================
C ==========================================================================
        SUBROUTINE HMODEL(AZM,ELV,H)
C jlfm/GSFC/920.1: 3/23/93
C -------------------------------------------------------------------
C Compute the "H" matrix for mount model update...
C       this is a 2 x 22 matrix.
C
C       INPUTS:  AZM:   Current mount azimuth (raw + offset)
C                ELV:   Current mount elevation (raw + offset)
C
C       OUTPUTS:  H:    "H" matrix
C
C -------------------------------------------------------------------
        IMPLICIT REAL*8 (A-H,O-Z)
        PARAMETER (RAD=57.295779513D0)
        DIMENSION H(2,22)
C
        AZR=AZM/RAD
        IF(ELV.LE.89.5) THEN
           ELR=ELV/RAD
        ELSE
           ELR=89.5D0/RAD
        ENDIF
        SINAZ=DSIN(AZR)
        SINEL=DSIN(ELR)
        COSAZ=DCOS(AZR)
        COSEL=DCOS(ELR)
        TANEL=SINEL/COSEL
        COS2EL=DCOS(2*ELR)
        SIN2EL=DSIN(2*ELR)
        COS2AZ=DCOS(2*AZR)
        SIN2AZ=DSIN(2*AZR)
C
        DO I=1,22
           DO J=1,2
              H(J,I)=0.D0
           END DO
        END DO

        !OLD Mount Model
        !H(1,1) =1.D0
        !H(1,2) =0.D0
        !H(1,3) =SINAZ*TANEL
        !H(1,4) =COSAZ*TANEL
        !H(1,5) =TANEL
        !H(1,6) =-1.D0/COSEL
        !H(1,7) =0.D0
        !H(1,8) =0.D0
C
        !H(2,1)=0.D0
        !H(2,2)=1.D0
        !H(2,3)=COSAZ
        !H(2,4)=-SINAZ
        !H(2,5)=0.D0
        !H(2,6)=0.D0
        !H(2,7)=COSEL
        !H(2,8)=SINEL
C
        H(1,1)=1.D0
        H(1,2)=COSAZ*TANEL
        H(1,3)=SINAZ*TANEL
        H(1,4)=1.D0/COSEL
        H(1,5)=COS2AZ*SINEL*TANEL
        H(1,6)=SIN2AZ*SINEL*TANEL
        H(1,7)=COSAZ*SINEL
        H(1,8)=SINAZ*SINEL
        H(1,9)=COSEL
        H(1,10)=0.D0
C
        H(2,11)=1.D0
        H(2,12)=COSAZ*SINEL
        H(2,13)=SINAZ*SINEL
        H(2,14)=COSEL
        H(2,15)=COS2AZ*SINEL*SINEL
        H(2,16)=SIN2AZ*SINEL*SINEL
        H(2,17)=COSAZ*SINEL*COSEL
        H(2,18)=SINAZ*SINEL*COSEL
        H(2,19)=COSEL*COSEL
        H(2,20)=SINEL
        H(2,21)=cos2el*cosaz
        H(2,22)=cos2el*sinaz
C
        RETURN
        END
